unit F;

interface

uses {$IFDEF WIN32} BDE,Windows, {ELSE} WinTypes,WinProcs,{$ENDIF}
     DbiErrs,DbiProcs,DbiTypes,DB,DBConsts,DBTables,Classes,SysUtils,Forms,
     Controls,Dialogs,Printers;

    function Ltrim(Cadena: string): string;
    function Rtrim(Cadena: string): string;
    function Alltrim(Cadena: string): string;
    function Space(I: Integer): string;
    function Saca1(var Cadena: string): string;
    function AlineaDcha(Cadena: string;K:Integer): string;
    function AlineaIzqda(Cadena: string;K:Integer): string;
    function Left(Cadena: string;K: Integer): string;
    function Hay(Cadena : String; Mayor : Integer): Boolean;
    function Replicate(Car: String; Longitud: Integer): String;
    function ExitFloat(Cadena: string): string;
    function ExitInteger(Cadena: string): string;

    function StrToPChar(S: string): Pchar;

    function fDbiCopyTable(TblName : TTable; Table_T: String; var Retorno :String): Boolean;
    function fDbiRegenIndexes(TblName : TTable ; var Retorno : String): Boolean;
    function fDbiPackTable(var TblName : TTable; bRegenIdxs: Boolean;
                           var Retorno : String): Boolean;
    function fDbiSaveChanges(TblName : TTable; var Retorno : String): Boolean;
    function RemoveMDXByte(dbFile: String): Boolean;
    function DeleteAllIndex(TblName : TTable): Boolean;
    function Recno(ATable: TTable): Longint;
    function GotoRecNo(Tabla : TTable; Registro : Longint; var Retorno : String): Boolean;
    function fDbiAddAlias(sAlias, sType, sParam : String; var Retorno : String):Boolean;
    procedure fDbiDeleteAlias(AliasName: String);
    function fDbiSortTable(SrcTbl, DestTbl: TTable; SortField: TField): longint;

    // Mira si existe un alias, y si no lo crea. sPath con '\'; sType dbase,paradox,msaccess
    function TestAlias(sAlias, sType, sPath : String): Boolean;

    procedure PrintPapel(Modelo : String); // Seleccionar el tamao del papel de la impresora

    function NSerieHD(Disco: String):String;

var
 Retorno : String;
 Ds,Ts : String;
 Dir       : String;

implementation

{ Elimina los espacios a la izquierda de una cadena }
function Ltrim(Cadena: string): string;
begin
  while pos(' ',Cadena) = 1 do
   begin
      Cadena := Copy(Cadena,2,Length(Cadena)-1);
  end;
  Result:= Cadena;
end;

{ Elimina los espacios a la derecha de una cadena }
function Rtrim(Cadena: string): string;
begin
  while Copy(Cadena,Length(Cadena),1) = ' ' do
  begin
    Cadena := Copy(Cadena,1,Length(Cadena) - 1);
  end;
  Result:= Cadena;
end;

{ Elimina los espacios a la Izqda. y derecha de una cadena }
function Alltrim(Cadena: string): string;
begin
  Result:= Ltrim(Rtrim(Cadena));
end;

{ Inserta I espacios }
function Space(I: Integer): String;
var
k      : Integer;
Cadena : string;
begin
  k      := 0;
  Cadena := '';
  while k < I do
  begin
    Cadena := Cadena + ' ';
    k      := K + 1;
  end;
  Result := Cadena;
end;

{ devuelve el primer caracter de la cadena y lo elimina de la cadena que se le pasa}
function Saca1(var Cadena: string): string;
var
 Primero : String;
begin
  if Length(Cadena) = 0 then Primero := '';

  if Length(Cadena) > 0 then Primero := Copy(Cadena,1,1);

  if Length(Cadena) > 1 then Cadena  := Copy(Cadena,2,Length(Cadena) - 1)
  else Cadena := '';

  Result  := Primero;
end;
{ Alinea a la derecha rellenando espacios hasta completar longitud K }
function AlineaDcha(Cadena: string;K: Integer): string;
begin
  if k = 0 then k := Length(Cadena);
  if k < Length(Cadena) then k := Length(Cadena);
  Cadena := Rtrim(Cadena);
  Cadena := Space(k - Length(Cadena)) + Cadena;
  Result := Cadena;
end;

{ Alinea a la Izquierda rellenando espacios hasta completar longitud K }
function AlineaIzqda(Cadena: string;K: Integer): string;
begin
  if k = 0 then k := Length(Cadena);
  if k < Length(Cadena) then k := Length(Cadena);
  Cadena := Ltrim(Cadena);
  Cadena := Cadena + Space(k - Length(Cadena));
  Result := Cadena;
end;

Function Left(Cadena: string;K: Integer): string;
{-Si la longitud pedida es mayor que la de la cadena, devuelve la cadena
  con espacios al final con la longitud de K.
 -Si la longitud de la Cadena es mayor que la de K, devuelve la cadena
  de la longitud de K igual que en dBase }
var
  LCadena : Integer;
begin
  LCadena := Length(Cadena);
  if (K > 0) and (LCadena > 0) then
    if LCadena < K then
       Cadena := Cadena + Space(K - LCadena)
      else
       Cadena := Copy(Cadena,1,K);

 Result := Cadena;
end;

{Devuelve True si la cadena tiene una longitud > que Mayor}
function Hay(Cadena : String; Mayor : Integer): Boolean;
begin
 if Length(AllTrim(Cadena)) > Mayor then Result := True else Result := False;
end;

function Replicate(Car: String; Longitud: Integer): String;
var
 i : Integer;
begin
 Result := '';
 for i := 1 to Longitud do Result := Result + Car[1];
end;

function ExitFloat(Cadena: string): string;
var
  K,Longitud : Integer;
  D,S,T      : String;
begin
  {Funcion de ambito general que interpreta y convierte una cadena de texto en
   valor preparado para convertirlo con StrToFloat() sin dar errores. Cambia los
   caracteres alfabeticos por 0 e interpreta los valores decimales de 0,.. si se
   introducen sin la coma. Igualmente sustituye el punto por la coma. Preparado
   para funcionar con el evento OnExit de un campo de edicion normal. Elimina la
   segunda coma y siguientes de una cadena}

  Longitud := Length(Cadena);         {guardar longitud original}
  Cadena   := Alltrim(Cadena);
  if Length(Alltrim(Cadena)) > 0 then begin {0}
   if Pos('.',Cadena) > 0 then      {Cambiar punto por coma}
    Cadena := Copy(Cadena,1,Pos('.',Cadena) - 1) + ',' +
              Copy(Cadena,Pos('.',Cadena) + 1,Length(Cadena) - Pos('.',Cadena));
   {Eliminacion de los segundos puntos si los hay}
   while Pos('.',Cadena) > 0 do begin {Cambiar siguientes puntos por nul}
    Cadena := Copy(Cadena,1,Pos('.',Cadena) - 1) +
              Copy(Cadena,Pos('.',Cadena) + 1,Length(Cadena) - Pos('.',Cadena));
   end;

   {Eliminar las comas del final de la cadena}
   while Copy(Cadena,Length(Cadena),1) = ',' do begin
    Cadena := Copy(Cadena,1,Length(Cadena)-1);
   end;

   {Eliminacion de las segundas comas si las hay}
   K := Pos(',',Cadena);
   if K > 0 then begin  {La cadena contiene al menos una coma}
    if Length(Cadena) > K then begin {controlamos que la coma no est en la ultima posicion}
     T      := Copy(Cadena,1,K); {guardar primera parte de la cadena incluida la coma}
     Cadena := Copy(Cadena,K+1,Length(Cadena)-K); {guardar el resto de la cadena para test}
     K      := Pos(',',Cadena);
     while Pos(',',Cadena) > 0 do begin {Cambiar siguientes puntos por nul}
      Cadena := Copy(Cadena,1,Pos(',',Cadena) - 1) +
              Copy(Cadena,Pos(',',Cadena) + 1,Length(Cadena) - Pos(',',Cadena));
     end;
     Cadena := T + Cadena; {volvemos a componer la cadena original}
    end;
   end;

   {Si la coma esta en primera posicion, inserta un 0 delante}
   if Copy(Cadena,1,1) = ',' then Cadena := '0' + Cadena;

   K := 1;
{1}while K <= Length(Cadena) do begin

    D := Copy(Cadena,K,1);

 {2}if K = 1 then begin
     if not ((D = '+') or (D = '-') or (D = '0') or (D = '1') or
             (D = '2') or (D = '3') or (D = '4') or (D = '5') or
             (D = '6') or (D = '7') or (D = '8') or (D = '9') or
             (D = ',')) then
      if Length(Cadena) > 1 then begin
       Cadena := Copy(Cadena,2,Length(Cadena) - 1);
       K      := 0;
      end else Cadena := '0';
    end;{2-}

    if Length(Cadena) > K then S := Copy(Cadena,K + 1,1); {Caracter siguiente}

    {Si se escribe 093 por ejemplo, interpreta que es decimal y pone coma}
    if (K = 1)and(Pos(',',Cadena) = 0)and(Length(Cadena) > 1)and(D = '0')and
       ((S = '1') or (S = '2') or (S = '3') or (S = '4') or (S = '5') or
        (S = '6') or (S = '7') or (S = '8') or (S = '9') or (S = ',')) then
      Cadena := '0,' + Copy(Cadena, 2, Length(Cadena) - 1);

     {Si se escribe -093 por ejemplo, interpreta que es decimal y pone coma}
    if (K = 2)and(Pos(',',Cadena) = 0)and(Length(Cadena) > 2)and
       (Copy(Cadena,1,2) = '-0')and
       ((S = '1') or (S = '2') or (S = '3') or (S = '4') or (S = '5') or
        (S = '6') or (S = '7') or (S = '8') or (S = '9') or (S = ',')) then
     Cadena := '-0,' + Copy(Cadena, 3, Length(Cadena) - 2);

    if (K > 1) then
     if not ((D = '0') or (D = '1') or (D = '2') or (D = '3') or
             (D = '4') or (D = '5') or (D = '6') or (D = '7') or
             (D = '8') or (D = '9') or (D = ',')) then
      if Length(Cadena) > K then
       Cadena := Copy(Cadena,1,K-1) + '0' + Copy(Cadena,K + 1,Length(Cadena) - K)
      else Cadena := Copy(Cadena,1,K-1) + '0';

    K := K + 1;
   end; {1-}

  end else Cadena := '0';     {0-}
  Cadena := AlineaIzqda(Cadena,Longitud);
  Cadena := FloatToStr(StrToFloat(AllTrim(Cadena)));
  Result:= Cadena;
end;

function ExitInteger(Cadena: string): string;
var
  K,Longitud : Integer;
  D,S        : String;
begin
 {Funcion de ambito general que interpreta y convierte una cadena de texto en
  valor preparado para convertirlo con StrToInteger() sin dar errores. Cambia los
  caracteres alfabeticos por 0 y elimina los valores decimales de 0,..}

 Longitud := Length(Cadena);         {guardar longitud original}
 Cadena   := Ltrim(Rtrim(Cadena));
 if Length(Ltrim(Cadena)) > 0 then begin {if 1}
  if Pos('.',Cadena) > 0 then      {Elimina lo que hay a partir del punto}
   Cadena := Copy(Cadena,1,Pos('.',Cadena) - 1);

  if Pos(',',Cadena) > 0 then      {Elimina lo que hay a partir de la coma}
   Cadena := Copy(Cadena,1,Pos(',',Cadena) - 1);

  if Length(Cadena) = 0 then begin {Si todavia hay caracteres a controlar}
   Cadena := '0';
   Cadena := AlineaIzqda(Cadena,Longitud);
   Result:= Cadena;
   Exit;
  end;

  K := 1;
  while K <= Length(Cadena) do begin {for 2}
   D := Copy(Cadena,K,1);
   if K = 1 then begin {Control del primer caracter con el signo}
    if not ((D = '+') or (D = '-') or (D = '0') or (D = '1') or
            (D = '2') or (D = '3') or (D = '4') or (D = '5') or
            (D = '6') or (D = '7') or (D = '8') or (D = '9')) then
     if Length(Cadena) > 1 then begin   {if 4}
      Cadena := Copy(Cadena,2,Length(Cadena) - 1);
      K      := 0;
     end else Cadena := '0';    {if 4-}
   end;                           {if 3-}

   if Length(Cadena) > K then S := Copy(Cadena,K + 1,1); {Caracter siguiente}

   if (K > 1) then  {Control del resto de los caracteres}
    if not ((D = '0') or (D = '1') or (D = '2') or (D = '3') or
            (D = '4') or (D = '5') or (D = '6') or (D = '7') or
            (D = '8') or (D = '9')) then
     if Length(Cadena) > K then
      Cadena := Copy(Cadena,1,K-1) + '0' +
                Copy(Cadena,K + 1,Length(Cadena) - K)
     else Cadena := Copy(Cadena,1,K-1) + '0';

   K := K + 1;
  end;
 end else Cadena := '0';
 Cadena := AlineaIzqda(Cadena,Longitud);
 Result:= Cadena;
end;

{ Convierte una String en PChar directamente}
function StrToPChar(S: string): Pchar;
var
  Ps,P : PChar;
begin
  GetMem(P,Length(S) + 1);
  StrPCopy(P,S);
  Ps     := P;
  FreeMem(P,Length(S) + 1);
  Result := Ps;
end;

function fDbiSaveChanges(TblName : TTable; var Retorno : String): Boolean;
var
 BdeResult : DbiResult;
begin
 { if not fDbiSaveChanges(Table1, Retorno) then ShowMessage(Retorno); }
 BdeResult := DbiSaveChanges(TblName.Handle);
 Case BdeResult of
  DBIERR_NONE        : Retorno := 'Los cambios han sido Salvados';
  DBIERR_INVALIDHNDL : Retorno := 'El cursor Handle no es valido o es nulo.';
  DBIERR_NODISKSPACE : Retorno := 'Insuficiente espacio en disco';
  DBIERR_NOTSUPPORTED: Retorno := 'DbiSaveChanges no soporta tablas SQL';
 else
  Retorno := 'El BDE retorna un error inexperado';
 end;
 Result := (BdeResult =DBIERR_NONE);
end;

function fDbiRegenIndexes(TblName : TTable ; var Retorno : String): Boolean;
var
 BdeResult : DbiResult;
begin
{
 Table1.Close;
 Table1.Exclusive := True;
 Table1.Open;
 if not fDbiRegenIndexes(Table1, Retorno) then ShowMessage(Retorno);
}
 BdeResult := DbiRegenIndexes(TblName.Handle);
 Case BdeResult of
  DBIERR_NONE           : Retorno := 'Todos los Indices de la tabla han sido Indexados';
  DBIERR_INVALIDHNDL    : Retorno := 'El cursor Handle no es valido o es nulo.';
  DBIERR_NEEDEXCLACCESS : Retorno := 'La Tabla '  + TblName.TableName + ' debe estar abierta en modo Exclusivo';
  DBIERR_NOTSUPPORTED   : Retorno := 'DbiRegenIndexes no soporta tablas SQL';
 else
  Retorno := 'El BDE retorna un error inexperado';
 end;
 Result := (BdeResult =DBIERR_NONE);
end;

function fDbiPackTable(var TblName : TTable; bRegenIdxs: Boolean;
                       var Retorno : String): Boolean;
var
 BdeResult : DbiResult;
 Props: CURProps;
 hDb: hDBIDb;
 TableDesc: CRTblDesc;
 bActive,bExclusive : Boolean;
begin
(*
 if not fDbiPackTable(Table1,
                      True, // Index to ended, True o False
                      Retorno) then ShowMessage(Retorno);
*)

 with TblName do begin
  bActive    := Active;
  bExclusive := Exclusive;
  if Active then Close;
  if not Exclusive then Exclusive := True;
  try
   Open;
  except
   Retorno := 'Cannot open the table in exclusive manner';
   Result := False;
   Exit;
  end;
 end;

 // Get the table properties to determine table type...
 Check(DbiGetCursorProps(TblName.Handle, Props));

 if Props.szTableType = szDBase then begin
  BdeResult := DbiPackTable(TblName.DBHandle, TblName.Handle, nil,szDBase, bRegenIdxs);
  Case BdeResult of
   DBIERR_NONE           : Retorno := 'All table Indexes have been indexed';
   DBIERR_INVALIDHNDL    : Retorno := 'The Name of Table or the pointer to the same is Void';
   DBIERR_NOSUCHTABLE	 : Retorno := 'The Table ' + TblName.TableName + ' not found';
   DBIERR_UNKNOWNTBLTYPE : Retorno := 'The type of table is unknown';
   DBIERR_NEEDEXCLACCESS : Retorno := 'The Table '  + TblName.TableName + 'it must be opened in exclusive manner';
  else
   Retorno := 'The BDE returns a not waited error';
  end;
  Result := (BdeResult = DBIERR_NONE);
 end else begin // La tabla no es dBase. Suponemos que es Paradox
  try
   // Si la tabla es Paradox, se llama a DbiDoRestructure...
   if Props.szTableType = szPARADOX then begin
     // Iniciar la estructura
     FillChar(TableDesc, sizeof(TableDesc), 0);
     // Obtener el database handle desde la tabla
     Check(DbiGetObjFromObj(hDBIObj(TblName.Handle), objDATABASE, hDBIObj(hDb)));
     // Poner el nombre de la tabla en la descripcin
     StrPCopy(TableDesc.szTblName, TblName.TableName);
     // Poner el tipo de la tabla en la Descripcin
     StrPCopy(TableDesc.szTblType, Props.szTableType);
     // Configurar la opcin Empaquetar en la descripcin
     TableDesc.bPack := True;
     // Cerrar la tabla antes de Reestructurar
     TblName.Close;
     // Llamar a DbiDoRestructure...
     Check(DbiDoRestructure(hDb, 1, @TableDesc, nil, nil, nil, False));
     Result := True;
    end;
   except
    Retorno := 'An exception has taken place when packing the Paradox  Table';
    Result := False;
   end;
 end;

 with TblName do begin
  Close;
  Exclusive := bExclusive;
  Active    := bActive;
 end;
end;

function fDbiCopyTable(TblName : TTable; Table_T: String; var Retorno :String): Boolean;
var
 pTable_T, pTable_S  : array[0..80] of char;
 BdeResult : DBIResult;
begin
 StrPCopy(pTable_T, Table_T);
 StrPCopy(pTable_S, TblName.TableName);

 BdeResult := DbiCopyTable( TblName.DBHandle, True, pTable_S, nil, pTable_T);
 Case BdeResult of
  DBIERR_NONE                : Retorno := 'La tabla  ha sido copiada.';
  DBIERR_INVALIDHNDL         : Retorno := 'El nombre de la Tabla o el puntero a la misma es Nulo';
  DBIERR_INVALIDPARAM        : Retorno := 'El nombre de las Tablas Origen o Destino no se ha indicado.';
  DBIERR_INVALIDFILENAME     : Retorno := 'Cadena vacia o Nombre Archivo no valido en nombres de Tablas. ';
  DBIERR_FILEEXISTS          : Retorno := 'La Tabla existe, y se ha especificado no sobreescribir.';
  DBIERR_FAMFILEINVALID      : Retorno := 'El archivo esta corrupto';
  DBIERR_NOSUCHTABLE	     : Retorno := 'La Tabla no Existe';
  DBIERR_NOTSUFFTABLERIGHTS  : Retorno := 'El usuario no tiene permiso para borrar la tabla destino.';
  DBIERR_NOTSUFFFAMILYRIGHTS : Retorno := 'El usuario no tiene derechos - Paradox.';
  DBIERR_LOCKED              : Retorno := 'La tabla est bloqueada por otro usuario.';
 else
  Retorno := 'El BDE retorna un error inexperado';
 end;
 Result := (BdeResult = DBIERR_NONE);
end;

function RemoveMDXByte(dbFile: String): Boolean;
{ Esta funcin acepta un archivo dbf como parmetro. Modifica la cabecera del
  fichero para eliminar la marca de fichero MDX asociado

  Debe pasarse el Path de D.O.S. Completo}

const
  Value: Byte = 0;
var
  F: File of byte;
begin
 Result := True;
 try
  AssignFile(F, dbFile);
  Reset(F);
  Seek(F, 28);
  Write(F, Value);
  CloseFile(F);
 except
  Result := False;
 end;
end;

function Recno(ATable: TTable): Longint;
var
  CP: CurProps;
  RP: RecProps;
begin
 with ATable do begin
  { Make sure it is a Paradox table!}
  UpdateCursorPos;                { sync BDE with Delphi}
  { Find out if table support Seq nums or Physical Rec nums}
  Check(DbiGetCursorProps(Handle, CP));
  Check(DbiGetRecord(Handle, dbiNOLOCK, nil, @RP));
  if StrComp(CP.szTableType, szDBASE) = 0 then
   Result := RP.iPhyRecNum
  else
   if StrComp(CP.szTableType, szPARADOX) = 0 then
    Result := RP.iSeqNum
   else
    { raise exception if it's not a Paradox or dBASE table}
    raise EDatabaseError.Create('Not a Paradox or dBASE table');
 end;
end;

function GotoRecNo(Tabla : TTable; Registro : Longint; var Retorno : String): Boolean;
var
 BdeResult: DbiResult;
begin
 BdeResult := DbiSetToRecordNo(Tabla.handle, Registro);
 Case BdeResult of
  DBIERR_NONE        : Result := True; {The cursor was successfully set to the record specified by iRecNo.}
  DBIERR_INVALIDHNDL : begin {The specified cursor handle is invalid or NULL.}
                        Retorno := 'El cursor de la tabla especificada es Nulo o No vlido';
                        Result  := False;
                       end;
  DBIERR_BOF         : begin {The specified record number is zero.}
                        Tabla.First;
                        Result := True;
                       end;
  DBIERR_EOF         : begin {The specified record number is greater than the number of records in the table.}
                        Tabla.Last;
                        Result := True;
                       end;
  DBIERR_NOTSUPPORTED : begin {This function is not supported for Paradox and SQL tables.}
                        Retorno := 'Esta Funcin no soporta Tablas Paradox ni SQL.';
                        Result  := False;
                       end;
 else
  Result  := False;
  Retorno := 'El BDE retorna un error inexperado';
 end;
 Tabla.UpdateCursorPos;
end;

function DeleteAllIndex(TblName : TTable): Boolean;
var
 Lista : TStringList;
 i     : Integer;
begin
 {Borrar todos los indices de una tabla}
 Result := True;
 try
  Lista := TStringList.Create;
  TblName.GetIndexNames(Lista);
  for i := 0 to Lista.Count - 1 do TblName.DeleteIndex(Lista[i]);
  Lista.Free;
 except
  Result := False;
 end;
end;

procedure PrintPapel(Modelo : String);
var
 fDevice,fDriver,fPort : PChar;
 fHandle : THandle;
 fDeviceMode : PDevMode;
begin
 // Para mas informacin y opciones, consultar en el API: TDevMode

 GetMem(fDevice,255);
 GetMem(fDriver,255);
 GetMem(fPort,255);
 Modelo := UpperCase(Modelo);

 {Configurar el objeto Printer}
 Printer.PrinterIndex := Printer.PrinterIndex; {Ojo, no quitar porque es un Bug}
 Printer.GetPrinter(fDevice, fDriver, fPort, fHandle); {Obtener los parametros de la impresora}

 if fHandle <> 0 then begin
  fDeviceMode := GlobalLock(fHandle);
  if       Modelo = 'A3'     then fDeviceMode^.dmPaperSize := DMPAPER_A3      // 297 x 420 mm
   else if Modelo = 'A4'     then fDeviceMode^.dmPaperSize := DMPAPER_A4     // 210 x 297 mm
   else if Modelo = 'A5'     then fDeviceMode^.dmPaperSize := DMPAPER_A5     // 148 x 210 mm
   else if Modelo = 'LETTER' then fDeviceMode^.dmPaperSize := DMPAPER_LETTER // 8 1/2 x 12 in.
   else if Modelo = 'FOLIO'  then fDeviceMode^.dmPaperSize := DMPAPER_FOLIO  // 8 1/2 x 13 in.
   else if Modelo = 'LEGAL'  then fDeviceMode^.dmPaperSize := DMPAPER_LEGAL  // 8 1/2 x 14 in.
   else ShowMessage('Tamao del papel no predeterminado');
 end else ShowMessage('Error al obtener el fHandle de Printer');

 FreeMem(fDevice,255);
 FreeMem(fDriver,255);
 FreeMem(fPort,255);

 (* // Otras opciones de papel estandar de Win95
DMPAPER_FIRST	DMPAPER_LETTER
DMPAPER_LETTER	Letter, 8 1/2 x 11 in.
DMPAPER_LETTERSMALL	Letter Small, 8 1/2 x 11 in.
DMPAPER_TABLOID	Tabloid, 11 x 17 in.
DMPAPER_LEDGER	Ledger, 17 x 11 in.
DMPAPER_LEGAL	Legal, 8 1/2 x 14 in.
DMPAPER_STATEMENT	Statement, 5 1/2 x 8 1/2 in.
DMPAPER_EXECUTIVE	Executive, 7 1/2 x 10 1/2 in.
DMPAPER_A3	A3, 297 x 420 mm
DMPAPER_A4	A4, 210 x 297 mm
DMPAPER_A4SMALL	A4 Small, 210 x 297 mm
DMPAPER_A5	A5, 148 x 210 mm
DMPAPER_B4	B4, 250 x 354 mm
DMPAPER_B5	B5, 182 x 257 mm
DMPAPER_FOLIO	Folio, 8 1/2 x 13 in.
DMPAPER_QUARTO	Quarto, 215 x 275 mm
DMPAPER_10X14	10 x 14 in.
DMPAPER_11X17	11 x 17 in.
DMPAPER_NOTE	Note, 8 1/2 x 11 in.
DMPAPER_ENV_9	Envelope #9, 3 7/8 x 8 7/8 in.
DMPAPER_ENV_10	Envelope #10, 4 1/8 x 9 1/2 in.
DMPAPER_ENV_11	Envelope #11, 4 1/2 x 10 3/8 in.
DMPAPER_ENV_12	Envelope #12, 4 1/2 x 11 in.
DMPAPER_ENV_14	Envelope #14, 5 x 11 1/2 in.
DMPAPER_CSHEET	C size sheet
DMPAPER_DSHEET	D size sheet
DMPAPER_ESHEET	E size sheet
DMPAPER_ENV_DL	Envelope DL, 110 x 220 mm
DMPAPER_ENV_C3	Envelope C3, 324 x 458 mm
DMPAPER_ENV_C4	Envelope C4, 229 x 324 mm
DMPAPER_ENV_C5	Envelope C5, 162 x 229 mm
DMPAPER_ENV_C6	Envelope C6, 114 x 162 mm
DMPAPER_ENV_C65	Envelope C65, 114 x 229 mm
DMPAPER_ENV_B4	Envelope B4, 250 x 353 mm
DMPAPER_ENV_B5	Envelope B5, 176 x 250 mm
DMPAPER_ENV_B6	Envelope B6, 176 x 125 mm
DMPAPER_ENV_ITALY	Envelope, 110 x 230 mm
DMPAPER_ENV_MONARCH	Envelope Monarch, 3 7/8 x 7 1/2 in.
DMPAPER_ENV_PERSONAL	Envelope, 3 5/8 x 6 1/2 in.
DMPAPER_FANFOLD_US	U.S. Standard Fanfold, 14 7/8 x 11 in.
DMPAPER_FANFOLD_STD_GERMAN	German Standard Fanfold, 8 1/2 x 12 in.
DMPAPER_FANFOLD_LGL_GERMAN	German Legal Fanfold, 8 1/2 x 13 in.
DMPAPER_LAST	German Legal Fanfold, 8 1/2 x 13 in.
DMPAPER_USER	User-defined end;
*)
end;

function NSerieHD(Disco: String):String;
var
 SerialNum : pdword;
 a, b      : dword;
 Buffer    : array [0..255] of char;
begin
 Result := '';
 if GetVolumeInformation(PChar(Disco[1] + ':\'), Buffer, SizeOf(Buffer),
                         SerialNum, a, b, nil, 0) then
  Result := IntToStr(SerialNum^);
end;

function fDbiAddAlias(sAlias, sType, sParam : String; var Retorno : String):Boolean;
var
 BdeResult : DbiResult;
begin
 { Ejemplo
 var
  sAlias,sType,sParam,Retorno : String;
  sLParam : TStrings;
 begin
  sAlias := 'Access0';
  sType  := 'MSACCESS';
  sParam := 'DATABASE NAME:D:\Access\Access0.mdb;' +
           'OPENMODE:READ/WRITE;';

  sLParam.Add('DATABASE NAME:D:\Access\Access0.mdb;');
  sLParam.Add('OPENMODE:READ/WRITE;');

  DbiInit(nil);
  if not fDbiAddAlias(sAlias, sType, sParam, Retorno) then ShowMessage(Retorno);
}

 BdeResult := DbiAddAlias(Nil, PChar(sAlias), PChar(sType), PChar(sParam), True);
 Case BdeResult of
  DBIERR_INVALIDPARAM  : Retorno := 'Null or invalid alias name. Invalid characters include a colon (:) and backslash (\). szASCII, szDBASE, and szPARADOX are entered as a STANDARD alias with the respective default driver.';
  DBIERR_NONE          : Retorno := 'The alias was added successfully.';
  DBIERR_NAMENOTUNIQUE : Retorno := 'Another alias with the same name already exists (applicable only when bPersistent is TRUE).';
  DBIERR_OBJNOTFOUND   : Retorno := 'One (or more) of the optional parameters passed in through pszParams was not found as a valid type in the driver section of the configuration file.';
 else
  Retorno := 'El BDE retorna un error inexperado';
 end;
 Result := (BdeResult = DBIERR_NONE);

end;

procedure fDbiDeleteAlias(AliasName: String);
begin
  Check(DbiDeleteAlias(nil, PChar(AliasName)));
end;

{Esta es la funcion original del BDE que permite ordenar por un Campo de la tabla.}
function fDbiSortTable(SrcTbl, DestTbl: TTable; SortField: TField): Longint;
var
  Field: Word;
  CaseIns: boolean;
  Recs: longint;

begin
  Recs := SrcTbl.RecordCount;
  CaseIns := True;
  Field := SortField.Index + 1;

  if DestTbl.Active = False then
    raise EDatabaseError.Create('Cannot complete operation with destination table closed');

  Check(DbiSortTable(SrcTbl.DBHandle, nil, nil, SrcTbl.Handle, nil, nil,
           DestTbl.Handle, 1, @Field, @CaseIns, nil, nil, False, nil, Recs));

  Result := Recs;
end;

function TestAlias(sAlias, sType, sPath : String): Boolean;
var
 Lista       : TStringList;
 i           : Integer;
 fConfigMode : TConfigMode;
begin
{Ejemplo de llamada:
 // Control y creacin del Alias en el BDE, en el directorio de la aplicacin
 Dir := ExtractFilePath(ExpandFileName(Application.ExeName));
 if Dir[Length(Dir)] <> '\' then Dir := Dir + '\';
 if not TestAlias('Codigos', 'dBase', Dir) then begin
  ShowMessage('No se puede crear el Alias "Codigos"');
  Application.Terminate;
 end;
}
 Lista  := TStringList.Create;
 Result := True;

 {Obtener los Alias de la sesion}
 try
  Session.GetAliasNames(Lista);
 except
  Result := False;
  Exit;
 end;

 {Mirar si existe el alias}
 i := 0;
 while (Length(Lista[i]) > 0) and (Lista.Count > 0) do begin
  if Lista[i] = sAlias then begin
   Exit;
  end;
  if i < (Lista.Count - 1) then Inc(i) else Break;
 end;

 //  Definir los Alias en funcin del tipo de Driver
 Lista.Clear;
 sType := UpperCase(sType);
 if (sType = 'DBASE') or (sType = 'PARADOX') then begin
  Lista.Add('DEFAULT DRIVER=' + sType);

  if sType = 'PARADOX' then Lista.Add('ENABLE BCD=FALSE');
  sType := 'STANDARD';

  if sPath[Length(sPath)] = '\' then sPath := Copy(sPath,1,Length(sPath)-1);
  Lista.Add('PATH=' + sPath);
 end;

  // Crear el nuevo Alias en el BDE
 fConfigMode := Session.ConfigMode;
 try
  DbiInit(nil);
  Session.AddAlias(sAlias, sType, Lista);
  Session.SaveConfigFile;
 except
  Result := False;
  Session.ConfigMode := fConfigMode;
 end;

end;

initialization

Ds := DateSeparator;
Ts := TimeSeparator;

end.
